#!/bin/sh

# Final attempt for scripting files for a nice indexed doxygen
# output. Main idea is to create a directory structure that is
# the same as the src directory in your grass package. 
# To do this a certain order of processing is needed, first 
# start with the includes and create a tag file (not sure if
# needed, but doxygen method is not working), secondly process
# the libraries with the include tagfile and create tagfiles.
# Last process each module with the libraries and include tags
# so it will become easier to see which functions belonging to
# libraries and which belong to the module itself.
# In order to do this will need 2 prepared Doxyfiles, 2 
# prepared standard .dox files and 1 changed .css file, html
# header and footer file.

# variables in Doxyfiles

# used are @1 till @8 for changeing input, output, generate
# tagfiles and adding $pwd where needed, index on/off, 
# recursive search on/off. In Doxyfile1 tagfiles already filled in.

# variables in .dox files

# used are @1 till @5 for filling in names and $pwd where
# needed.

# variables in .css files

# None. Prepared for adding path to mainindex and module
# indexes, and some formatting to resemble grass webpage.  

# variables in html header 

# used are @2 and @3 for filling in paths to mainindex and
# module indexes in header files. @1 Obsolete. Also added
# grass logo.

# Global and other local variables

# mainly e (as in exclude directories, files not relevant)
# and other letters like a, b, c etc.


# Doxygen Include

a=$PWD
c="<div class=\"qindex1\"><a class=\"qindexHL\" href=\"$a/doxygenhtml/index.html\">Main\&nbsp;Index</a> | <a class=\"qindexHL\" href=\"#top\">Top</a> </div>"

if [ ! -d doxygenhtml ];
then
mkdir doxygenhtml;
fi 

if [ ! -d doxygenhtml/include ];
then
mkdir doxygenhtml/include;
fi 

sed -e "s%@1%"doxygen1.css"%" -e "s%@2%$c%" -e "s%@3%$a%" "src/Howto/header.html" > "src/Howto/header1.html"

if [ ! -e src/include/include.dox ]

then

sed -e "s%@1%include%g" -e "s%@2%include%" -e "s%@3%\$Grass/src/include%" -e "s%@4%\$Grass/doxygenhtml/include%" "src/Howto/libmod.dox" > "doxygenhtml/include/include.dox"

sed -e "s%@1%src/include%" -e "s%@2%doxygenhtml/include%" -e "s%@3%doxygenhtml/include%" -e "s%@5%%" -e "s%@6%doxygenhtml/include/include.tag%" -e "s%@4%doxygen1.css%" -e "s%@7%YES%" -e "s%@8%NO%" "src/Howto/Doxyfile" > "Doxyfile"

else

sed -e "s%@1%src/include%" -e "s%@2%%" -e "s%@3%doxygenhtml/include%" -e "s%@5%%" -e "s%@6%doxygenhtml/include/include.tag%" -e "s%@4%doxygen1.css%" -e "s%@7%YES%" -e "s%@8%NO%" "src/Howto/Doxyfile" > "Doxyfile"

fi 

doxygen Doxyfile



# Doxygen libes


for i in `find -path './src/libes/*' -mindepth 1 -maxdepth 3 -type d -print`
do
a=$PWD
b=`basename $i` #eg gis
c=`dirname $i | sed -e "s%./src/%%"` #libes
d=`basename $i |sed "s%\.%%g"` #eg gis no points in names
e=( CVS CMD fonts gui include libes scripts tcltkgrass Howto bwidget ) #exclude!! 
f="<div class=\"qindex1\"><a class=\"qindexHL\" href=\"$a/doxygenhtml/index.html\">Main\&nbsp;Index</a> | <a class=\"qindexHL\" href=\"$a/doxygenhtml/$c/index.html\">$c\&nbsp;Index</a> | <a class=\"qindexHL\" href=\"#top\">Top</a> </div>"
l=1

for n in ${e[@]}
do
if [ "$b" = "$n" ]
then
let "l+=1"
fi
done

if [ $l = 1 ]
then

if [ ! -d doxygenhtml/$c/$b ]
then
mkdir -p doxygenhtml/$c/$b
fi

if [ ! -e src/$c/$b/$.dox ]

then

sed -e "s%@1%"doxygen1.css"%" -e "s%@2%$f%" -e "s%@3%$a%" "src/Howto/header.html" > "src/Howto/header1.html"

sed -e "s%@1%$b%g" -e "s%@2%$d%" -e "s%@3%\$Grass/doxygenhtml/$c/$b%" -e "s%@4%\$Grass/src/$c/$b%" "src/Howto/libmod.dox" > "doxygenhtml/$c/$b/$b.dox"

sed -e "s%@1%src/$c/$b%" -e "s%@2%doxygenhtml/$c/$b%" -e "s%@3%doxygenhtml/$c/$b%" -e "s%@5%doxygenhtml/include/include.tag%" -e "s%@6%doxygenhtml/$c/$b/$b.tag%" -e "s%@4%doxygen1.css%" -e "s%@7%YES%" -e "s%@8%NO%" "src/Howto/Doxyfile" > "Doxyfile"

else

sed -e "s%@1%"doxygen1.css"%" -e "s%@2%$f%" -e "s%@3%$a%" "src/Howto/header.html" > "src/Howto/header1.html"

sed -e "s%@1%src/$c/$b%" -e "s%@2%%" -e "s%@3%doxygenhtml/$c/$b%" -e "s%@5%doxygenhtml/include/include.tag=$a/doxygenhtml/include%" -e "s%@6%doxygenhtml/$c/$b/$b.tag%" -e "s%@4%doxygen1.css%" -e "s%@7%YES%" -e "s%@8%NO%" "src/Howto/Doxyfile" > "Doxyfile"

fi

doxygen Doxyfile

fi
done


# Index for libes 

a=$PWD
f="<div class=\"qindex1\"><a class=\"qindexHL\" href=\"$a/doxygenhtml/index.html\">Main\&nbsp;Index</a> | <a class=\"qindexHL\" href=\"#top\">Top</a> </div>"

if [ ! -e src/libes/index.dox ]

then

sed -e "s%@1%"doxygen1.css"%" -e "s%@2%$f%" -e "s%@3%$a%" "src/Howto/header.html" > "src/Howto/header1.html"

sed -e "s%@1%src/libes%" -e "s%@2%doxygenhtml/libes/%" -e "s%@3%doxygenhtml/libes%" -e "s%@5%%" -e "s%@6%%" -e "s%@4%doxygen1.css%" -e "s%@7%NO%" -e "s%@8%YES%" "src/Howto/Doxyfile" > "Doxyfile"

sed -e "s%@1%libes%" -e "s%@2%libes%" -e "s%@3%\$Grass/doxygenhtml/libes%" -e "s%@4%\$Grass/src/libes%" "src/Howto/stdindex.dox" > "doxygenhtml/libes/index.dox"

for i in `find -path './src/libes/*' -maxdepth 3 -type d -print`
do
b=`dirname $i | sed -e "s%./src/%%"` #/libes
c=`basename $i` #eg gis
e=( CVS bwidget unused ) #exclude!! 
l=1

for n in ${e[@]}
do
if [ $c = $n ]
then
let "l+=1"
fi 
done

if [ $l = 1 ]
then

z="<li><a href="$c/index.html">$c</a></li>"

sed -e "s%@5%$z\n"@5"%" "doxygenhtml/libes/index.dox" > "doxygenhtml/libes/index.bak"

mv "doxygenhtml/libes/index.bak" "doxygenhtml/libes/index.dox"

fi
done

sed -e "/"@5"/d" "doxygenhtml/libes/index.dox" > "doxygenhtml/libes/index.bak" 
mv "doxygenhtml/libes/index.bak" "doxygenhtml/libes/index.dox"

else

sed -e "s%@1%"doxygen1.css"%" -e "s%@2%$f%" -e "s%@3%$a%" "src/Howto/header.html" > "src/Howto/header1.html"

sed -e "s%@1%src/libes%" -e "s%@2%%" -e "s%@3%doxygenhtml/libes%" -e "s%@5%%" -e "s%@6%%" -e "s%@4%doxygen1.css%" -e "s%@7%NO%" -e "s%@8%YES%" "src/Howto/Doxyfile" > "Doxyfile"

fi

doxygen Doxyfile


# Doxygen modules

for i in `find -path './src/*' -mindepth 3 -maxdepth 3 -type d -print`
do
a=$PWD
b=`basename $i` #eg module eg r.patch
c=`dirname $i | sed -e "s%./src/%%"` #modulegroup eg raster
d=`basename $i |sed "s%\.%%g"` #eg rpatch no points in names
#e=( CMD CVS display fonts front.end general gui Howto imagery include libes mapdev misc paint ps.map raster scripts sites tcltkgrass ) #exclude!!
e=( CMD CVS display fonts front.end gui Howto imagery include libes mapdev misc paint ps.map raster scripts sites tcltkgrass ) #exclude all except general modules!! 
f="<div class=\"qindex1\"><a class=\"qindexHL\" href=\"$a/doxygenhtml/index.html\">Main\&nbsp;Index</a> | <a class=\"qindexHL\" href=\"$a/doxygenhtml/$c/index.html\">$c\&nbsp;Index</a> | <a class=\"qindexHL\" href=\"#top\">Top</a> </div>"
l=1

for n in ${e[@]}
do
if [[ $b = $n || $c = $n ]]
then
let "l+=1"
fi 
done

if [ $l = 1 ]
then

if [ ! -d doxygenhtml/$c/$b ]
then
mkdir -p doxygenhtml/$c/$b
fi

if [ ! -e src/$c/$b/$b.dox ]

then

sed -e "s%@1%"doxygen1.css"%" -e "s%@2%$f%" -e "s%@3%$a%" "src/Howto/header.html" > "src/Howto/header1.html"

sed -e "s%@1%$b%g" -e "s%@2%$d%" -e "s%@3%\$Grass/doxygenhtml/$c/$b%" -e "s%@4%\$Grass/src/$c/$b%" "src/Howto/libmod.dox" > "doxygenhtml/$c/$b/$b.dox"

sed -e "s%@1%src/$c/$b%" -e "s%@2%doxygenhtml/$c/$b%" -e "s%@3%doxygenhtml/$c/$b%" -e "s%@5%$a%g" -e "s%@6%%" -e "s%@4%doxygen1.css%" -e "s%@7%YES%" -e "s%@8%NO%" "src/Howto/Doxyfile1" > "Doxyfile"

else

sed -e "s%@1%"doxygen1.css"%" -e "s%@2%$f%" -e "s%@3%$a%" "src/Howto/header.html" > "src/Howto/header1.html"

sed -e "s%@1%src/$c/$b%" -e "s%@2%%" -e "s%@3%doxygenhtml/$c/$b%" -e "s%@5%doxygenhtml/include/include.tag=$a/doxygenhtml/include%" -e "s%@6%doxygenhtml/$c/$b/$b.tag%" -e "s%@4%doxygen1.css%" -e "s%@7%YES%" -e "s%@8%NO%" "src/Howto/Doxyfile" > "Doxyfile"

fi

doxygen Doxyfile

fi
done

# Index for modules group eg raster

for i in `find -path './src/*' -mindepth 2 -maxdepth 2 -type d -print`
do
a=$PWD
b=`basename $i` #modulegroup
c=`basename $i | sed -e "s%\.%%g"`
e=( CMD CVS display fonts front.end gui Howto imagery include libes mapdev misc paint ps.map raster scripts sites tcltkgrass ) #exclude all except general modules!! 
f="<div class=\"qindex1\"><a class=\"qindexHL\" href=\"$a/doxygenhtml/index.html\">Main\&nbsp;Index</a> | <a class=\"qindexHL\" href=\"#top\">Top</a> </div>"
l=1

for n in ${e[@]}
do
if [ $b = $n ]
then
let "l+=1"
fi 
done

if [ $l = 1 ]
then

if [ ! -e src/$b/index.dox ]

then

sed -e "s%@1%"doxygen1.css"%" -e "s%@2%$f%" -e "s%@3%$a%" "src/Howto/header.html" > "src/Howto/header1.html"

sed -e "s%@1%src/$b%" -e "s%@2%doxygenhtml/$b/%" -e "s%@3%doxygenhtml/$b%" -e "s%@5%%" -e "s%@6%%" -e "s%@4%doxygen1.css%" -e "s%@7%NO%" -e "s%@8%YES%" "src/Howto/Doxyfile" > "Doxyfile"

sed -e "s%@1%$b%" -e "s%@2%$c%" -e "s%@3%\$Grass/doxygenhtml/$b%" -e "s%@4%\$Grass/src/$b%" "src/Howto/stdindex.dox" > "doxygenhtml/$b/index.dox"

for i in `find -path './src/*' -mindepth 3 -maxdepth 3 -type d -print`
do
b=`dirname $i | sed -e "s%./src/%%"` # eg raster
c=`basename $i` #eg r.patch
e=( CMD CVS display fonts front.end gui Howto imagery include libes mapdev misc paint ps.map raster scripts sites tcltkgrass ) #exclude all except general modules!! 
l=1

for n in ${e[@]}
do
if [[ $b = $n || $c = $n ]]
then
let "l+=1"
fi 
done

if [ $l = 1 ]
then

z="<li><a href="$c/index.html">$c</a></li>"

sed -e "s%@5%$z\n"@5"%" "doxygenhtml/$b/index.dox" > "doxygenhtml/$b/index.bak"

mv "doxygenhtml/$b/index.bak" "doxygenhtml/$b/index.dox"

fi
done

else

sed -e "s%@1%"doxygen1.css"%" -e "s%@2%$f%" -e "s%@3%$a%" "src/Howto/header.html" > "src/Howto/header1.html"

sed -e "s%@1%src/$b%" -e "s%@2%%" -e "s%@3%doxygenhtml/$b%" -e "s%@5%%" -e "s%@6%%" -e "s%@4%doxygen1.css%" -e "s%@7%NO%" -e "s%@8%YES%" "src/Howto/Doxyfile" > "Doxyfile"

fi
fi
done

for i in `find -path './doxygenhtml/*' -mindepth 2 -maxdepth 2 -type d -print`
do
b=`echo $i | sed -e "s%./%%"`

if [ -e $b/index.dox ]
then

sed -e "/"@5"/d" "$b/index.dox" > "$b/index.bak" 
mv "$b/index.bak" "$b/index.dox"
fi
done

doxygen Doxyfile


# Mainindex

a=$PWD
f="<div class=\"qindex1\"><a class=\"qindexHL\" href=\"#top\">Top</a> </div>"

if [ ! -e src/index.dox ]

then

sed -e "s%@1%"doxygen1.css"%" -e "s%@2%$f%" -e "s%@3%$a%" "src/Howto/header.html" > "src/Howto/header1.html"

sed -e "s%@1%src%" -e "s%@2%doxygenhtml%" -e "s%@3%doxygenhtml%" -e "s%@5%%" -e "s%@6%%" -e "s%@4%doxygen1.css%" -e "s%@7%NO%" -e "s%@8%YES%" "src/Howto/Doxyfile" > "Doxyfile"

sed -e "s%@1%MainIndex%" -e "s%@2%mainindex%" -e "s%@3%\$Grass/doxygenhtml%" -e "s%@4%\$Grass/src%" "src/Howto/stdindex.dox" > "doxygenhtml/index.dox"

for i in `find -path './src/*' -maxdepth 2 -type d -print`
do
b=`basename $i` # eg raster
e=( CMD CVS display fonts front.end gui Howto imagery mapdev misc paint ps.map raster scripts sites tcltkgrass ) #exclude all except general modules!!
l=1

for n in ${e[@]}
do
if [ $b = $n ]
then
let "l+=1"
fi 
done

if [ $l = 1 ]
then

z="<li><a href="$b/index.html">$b</a></li>"

sed -e "s%@5%$z\n"@5"%" "doxygenhtml/index.dox" > "doxygenhtml/index.bak"

mv "doxygenhtml/index.bak" "doxygenhtml/index.dox"

fi
done

sed -e "/"@5"/d" "doxygenhtml/index.dox" > "doxygenhtml/index.bak" 
mv "doxygenhtml/index.bak" "doxygenhtml/index.dox"

else

sed -e "s%@1%"doxygen1.css"%" -e "s%@2%$f%" -e "s%@3%$a%" "src/Howto/header.html" > "src/Howto/header1.html"

sed -e "s%@1%src%" -e "s%@2%%" -e "s%@3%doxygenhtml%" -e "s%@5%%" -e "s%@6%%" -e "s%@4%doxygen1.css%" -e "s%@7%NO%" -e "s%@8%YES%" "src/Howto/Doxyfile" > "Doxyfile"

fi

doxygen Doxyfile

rm Doxyfile
